#pragma once
#include "caosdb/handler_interface.h"             // for HandlerTag, Handl...
#include "caosdb/transaction_status.h"            // for TransactionStatus
#include <grpcpp/impl/codegen/client_context.h>   // for ClientContext
#include <grpcpp/impl/codegen/completion_queue.h> // for CompletionQueue
#include <grpcpp/impl/codegen/status.h>           // for Status

namespace caosdb::transaction {

class UnaryRpcHandler : public HandlerInterface {
public:
  inline UnaryRpcHandler(grpc::CompletionQueue *completion_queue)
    : state_(CallState::NewCall), completion_queue(completion_queue),
      transaction_status(TransactionStatus::EXECUTING()) {}

  void Start() override {
    transaction_status = TransactionStatus::EXECUTING();
    OnNext(true);
  }

  bool OnNext(bool ok) override;

  void Cancel() override;

  TransactionStatus GetStatus() override { return transaction_status; }

protected:
  virtual void handleNewCallState() = 0;
  virtual void handleReceivingFileState() = 0;
  void handleCallCompleteState();

  enum class CallState { NewCall, ReceivingFile, CallComplete };
  CallState state_;
  grpc::CompletionQueue *completion_queue;

  grpc::ClientContext call_context;
  grpc::Status status_;
  TransactionStatus transaction_status;
};

} // namespace caosdb::transaction
